org.mozilla.javascript.ast

## Class ArrayComprehensionLoop

- java.lang.Object
- - org.mozilla.javascript.Node
  - - org.mozilla.javascript.ast.AstNode
    - - org.mozilla.javascript.ast.Jump
      - - org.mozilla.javascript.ast.Scope
        - - org.mozilla.javascript.ast.Loop
          - - org.mozilla.javascript.ast.ForInLoop
            - - org.mozilla.javascript.ast.ArrayComprehensionLoop

All Implemented Interfaces:
  java.lang.Comparable<AstNode>, java.lang.Iterable<Node>

    public class ArrayComprehensionLoop
    extends ForInLoop

AST node for a single 'for (foo in bar)' loop construct in a JavaScript 1.7 Array comprehension. This node type is almost equivalent to a `ForInLoop`, except that it has no body statement. Node type is `Token.FOR`.

### Nested Class Summary

### Nested classes/interfaces inherited from class org.mozilla.javascript.ast.AstNode

`AstNode.DebugPrintVisitor, AstNode.PositionComparator`

### Nested classes/interfaces inherited from class org.mozilla.javascript.Node

`Node.NodeIterator`

### Field Summary

### Fields inherited from class org.mozilla.javascript.ast.ForInLoop

`eachPosition, inPosition, isForEach, iteratedObject, iterator`

### Fields inherited from class org.mozilla.javascript.ast.Loop

`body, lp, rp`

### Fields inherited from class org.mozilla.javascript.ast.Scope

`parentScope, symbolTable, top`

### Fields inherited from class org.mozilla.javascript.ast.Jump

`target`

### Fields inherited from class org.mozilla.javascript.ast.AstNode

`length, parent, position`

### Fields inherited from class org.mozilla.javascript.Node

`ATTRIBUTE_FLAG, BOTH, CASEARRAY_PROP, CATCH_SCOPE_PROP, CONTROL_BLOCK_PROP, DECR_FLAG, DESCENDANTS_FLAG, DESTRUCTURING_ARRAY_LENGTH, DESTRUCTURING_NAMES, DESTRUCTURING_PARAMS, DESTRUCTURING_SHORTHAND, DIRECTCALL_PROP, END_DROPS_OFF, END_RETURNS, END_RETURNS_VALUE, END_UNREACHED, END_YIELDS, EXPRESSION_CLOSURE_PROP, first, FUNCTION_PROP, GENERATOR_END_PROP, INCRDECR_PROP, ISNUMBER_PROP, JSDOC_PROP, LABEL_ID_PROP, last, LAST_PROP, LEFT, lineno, LOCAL_BLOCK_PROP, LOCAL_PROP, MEMBER_TYPE_PROP, NAME_PROP, next, NON_SPECIALCALL, OBJECT_IDS_PROP, PARENTHESIZED_PROP, POST_FLAG, PROPERTY_FLAG, propListHead, REGEXP_PROP, RIGHT, SKIP_INDEXES_PROP, SPECIALCALL_EVAL, SPECIALCALL_PROP, SPECIALCALL_WITH, TARGETBLOCK_PROP, type, VARIABLE_PROP`

### Constructor Summary

Constructors
Constructor and Description
`ArrayComprehensionLoop()`
`ArrayComprehensionLoop(int pos)`
`ArrayComprehensionLoop(int pos, int len)`

### Method Summary

Methods
`AstNode` `getBody()` Returns `null` for loop body
`void` `setBody(AstNode body)` Throws an exception on attempts to set the loop body.
`java.lang.String` `toSource(int depth)` Emits source code for this node.
`void` `visit(NodeVisitor v)` Visits the iterator expression and the iterated object expression.

### Methods inherited from class org.mozilla.javascript.ast.ForInLoop

`getEachPosition, getInPosition, getIteratedObject, getIterator, isForEach, setEachPosition, setInPosition, setIsForEach, setIteratedObject, setIterator`

### Methods inherited from class org.mozilla.javascript.ast.Loop

`getLp, getRp, setLp, setParens, setRp`

### Methods inherited from class org.mozilla.javascript.ast.Scope

`addChildScope, clearParentScope, getChildScopes, getDefiningScope, getParentScope, getStatements, getSymbol, getSymbolTable, getTop, joinScopes, putSymbol, replaceWith, setParentScope, setSymbolTable, setTop, splitScope`

### Methods inherited from class org.mozilla.javascript.ast.Jump

`getContinue, getDefault, getFinally, getJumpStatement, getLoop, setContinue, setDefault, setFinally, setJumpStatement, setLoop`

### Methods inherited from class org.mozilla.javascript.ast.AstNode

`addChild, assertNotNull, codeBug, compareTo, debugPrint, depth, getAbsolutePosition, getAstRoot, getEnclosingFunction, getEnclosingScope, getLength, getLineno, getParent, getPosition, hasSideEffects, makeIndent, operatorToString, printList, setBounds, setLength, setParent, setPosition, setRelative, shortName, toSource`

### Methods inherited from class org.mozilla.javascript.Node

`addChildAfter, addChildBefore, addChildrenToBack, addChildrenToFront, addChildToBack, addChildToFront, getChildBefore, getDouble, getExistingIntProp, getFirstChild, getIntProp, getJsDoc, getJsDocNode, getLastChild, getLastSibling, getNext, getProp, getScope, getString, getType, hasChildren, hasConsistentReturnUsage, iterator, labelId, labelId, newNumber, newString, newString, newTarget, putIntProp, putProp, removeChild, removeChildren, removeProp, replaceChild, replaceChildAfter, resetTargets, setDouble, setJsDocNode, setLineno, setScope, setString, setType, toString, toStringTree`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### ArrayComprehensionLoop

    public ArrayComprehensionLoop()

#### ArrayComprehensionLoop

    public ArrayComprehensionLoop(int pos)

#### ArrayComprehensionLoop

    public ArrayComprehensionLoop(int pos,
                          int len)

### Method Detail

#### getBody

    public AstNode getBody()

Returns `null` for loop body

Overrides:
  `getBody` in class `Loop`
Returns:
  loop body (always `null` for this node type)

#### setBody

    public void setBody(AstNode body)

Throws an exception on attempts to set the loop body.

Overrides:
  `setBody` in class `Loop`
Parameters:
  `body` - loop body
Throws:
  `java.lang.UnsupportedOperationException`

#### toSource

    public java.lang.String toSource(int depth)

Description copied from class: `AstNode`
Emits source code for this node. Callee is responsible for calling this function recursively on children, incrementing indent as appropriate.

Note: if the parser was in error-recovery mode, some AST nodes may have `null` children that are expected to be non-`null` when no errors are present. In this situation, the behavior of the `toSource` method is undefined: `toSource` implementations may assume that the AST node is error-free, since it is intended to be invoked only at runtime after a successful parse.

Overrides:
  `toSource` in class `ForInLoop`
Parameters:
  `depth` - the current recursion depth, typically beginning at 0 when called on the root node.

#### visit

    public void visit(NodeVisitor v)

Visits the iterator expression and the iterated object expression. There is no body-expression for this loop type.

Overrides:
  `visit` in class `ForInLoop`
Parameters:
  `v` - the object to call with this node and its children